/**
 * {解析当前系统环境}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/07/18 16:16:02
 */

const UA = navigator.userAgent.toLowerCase()
const UNKNOW_MATCH = [null, 'unknow']

const IS_CHROME = !!window.chrome
const IS_FIREFOX = !!window.sidebar

const IS_LINUX = UA.includes('linux')
const IS_WIN = UA.includes('windows nt')
const IS_ANDROID = UA.includes('android')
const IS_IOS =
  UA.includes('iphone') || UA.includes('ipad') || UA.includes('ipod')
const IS_MOBILE = IS_ANDROID || IS_IOS || UA.includes('mobile')

const OS_NAME = IS_ANDROID
  ? 'Android'
  : IS_IOS
  ? 'IOS'
  : IS_LINUX
  ? 'Linux'
  : IS_WIN
  ? 'Windows'
  : 'MacOS'
const OS_VERSION = IS_ANDROID ? UA.match(/android ([\d\.]*?);/)[1] : ''

const SCREEN = `${screen.width} x ${screen.height}`

const BROWSER_NAME = IS_IOS
  ? 'Safari'
  : IS_CHROME
  ? 'Chrome'
  : IS_FIREFOX
  ? 'Firefox'
  : 'Unknow'

const GENERAL_VERSION = UA.match(/version\/([\d\.]*?) /) || UNKNOW_MATCH
const CHROME_VERSION =
  IS_CHROME && (UA.match(/chrome\/([\d\.]*?) /) || UNKNOW_MATCH)
const IPAD_WEBKIT_VERSION =
  IS_IOS && (UA.match(/crios\/([\d\.]*?) /) || GENERAL_VERSION)

const BROWSER_VERSION = IS_IOS
  ? IPAD_WEBKIT_VERSION[1]
  : IS_CHROME
  ? CHROME_VERSION[1]
  : GENERAL_VERSION[1]

export { OS_NAME, OS_VERSION, BROWSER_NAME, BROWSER_VERSION, SCREEN }
